/*
 * Mohist - MohistMC
 * Copyright (C) 2018-2022.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 */

package com.mohistmc.entity;

import com.mohistmc.api.EntityAPI;
import net.minecraft.entity.projectile.ThrowableEntity;
import org.bukkit.craftbukkit.v1_16_R3.CraftServer;
import org.bukkit.craftbukkit.v1_16_R3.entity.CraftProjectile;
import org.bukkit.entity.EntityType;

public class CraftCustomThrowableEntity extends CraftProjectile {

    public String entityName;

    public CraftCustomThrowableEntity(CraftServer server, ThrowableEntity entity) {
        super(server, entity);
        this.entityName = EntityAPI.entityName(entity);
    }

    // Mohist start - Fix Savage&Ravage cast exception
    @Override
    public ThrowableEntity getHandle() {
        return (ThrowableEntity) entity;
    }
    // Mohist end

    @Override
    public EntityType getType() {
        return EntityAPI.entityType(entityName);
    }

    @Override
    public String toString() {
        return "CraftCustomThrowableEntity{" + entityName + '}';
    }
}
